#ifndef ADECTL_CMD_H_INCLUDED
#define ADECTL_CMD_H_INCLUDED

// Used adresses
#define ADD_S_UDP		 0
#define ADD_D_UDP		 4
#define ADD_DSCP		 8
#define ADD_ECN     	12
#define ADD_IDENT_FL    16
#define ADD_FLAG_NH		20	
#define ADD_TTL_HL		24
#define ADD_S_IP1		28
#define ADD_S_IP2		32
#define ADD_S_IP3		36
#define ADD_S_IP4		40
#define ADD_D_IP1		44
#define ADD_D_IP2		48
#define ADD_D_IP3		52
#define ADD_D_IP4		56
#define ADD_D_MACU		60
#define ADD_D_MACL		64
#define ADD_S_MACU		68
#define ADD_S_MACL		72
#define ADD_VER			76

int rw_srcport(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_dstport(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_dscp(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_ecn(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_identification(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_flags(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_ttl(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_srcip(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_dstip(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_srcmac(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int rw_dstmac(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);
int r_version(struct hwio_comp *c, hwio_tool_comp_err_t err,
		const struct hwio_tool_params *params);

#endif // ADECTL_CMD_H_INCLUDED 
